The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::DelayA Class Reference

STK allpass interpolating delay line class. More...

`#include <DelayA.h>`

Inheritance diagram for stk::DelayA:

## Public Member Functions
| DelayA (StkFloat delay=0.5, unsigned long maxDelay=4095)
| Default constructor creates a delay-line with maximum length of 4095 samples and delay = 0.5.
| ~DelayA ()
| Class destructor.
void | clear (void)
| Clears all internal states of the delay line.
unsigned long | getMaximumDelay (void)
| Get the maximum delay-line length.
void | setMaximumDelay (unsigned long delay)
| Set the maximum delay-line length.
void | setDelay (StkFloat delay)
| Set the delay-line length.
StkFloat | getDelay (void) const
| Return the current delay-line length.
StkFloat | tapOut (unsigned long tapDelay)
| Return the value at tapDelay samples from the delay-line input.
void | tapIn (StkFloat value, unsigned long tapDelay)
| Set the value at tapDelay samples from the delay-line input.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | nextOut (void)
| Return the value which will be output by the next call to tick().
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK allpass interpolating delay line class.

This class implements a fractional-length digital delay-line using a first-order allpass filter. If the delay and maximum length are not specified during instantiation, a fixed maximum length of 4095 and a delay of 0.5 is set.

An allpass filter has unity magnitude gain but variable phase delay properties, making it useful in achieving fractional delays without affecting a signal's frequency magnitude response. In order to achieve a maximally flat phase delay response, the minimum delay possible in this implementation is limited to a value of 0.5.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ DelayA()

stk::DelayA::DelayA | ( | StkFloat | delay = `0.5`,
|  | unsigned long | maxDelay = `4095`
| ) |  |

Default constructor creates a delay-line with maximum length of 4095 samples and delay = 0.5.

An StkError will be thrown if the delay parameter is less than zero, the maximum delay parameter is less than one, or the delay parameter is greater than the maxDelay value.

## Member Function Documentation

## ◆ setMaximumDelay()

void stk::DelayA::setMaximumDelay | ( | unsigned long | delay | ) |

Set the maximum delay-line length.

This method should generally only be used during initial setup of the delay line. If it is used between calls to the tick() function, without a call to clear(), a signal discontinuity will likely occur. If the current maximum length is greater than the new length, no memory allocation change is made.

## ◆ setDelay()

void stk::DelayA::setDelay | ( | StkFloat | delay | ) |

Set the delay-line length.

The valid range for delay is from 0.5 to the maximum delay-line length.

## ◆ tapOut()

StkFloat stk::DelayA::tapOut | ( | unsigned long | tapDelay | ) |

Return the value at tapDelay samples from the delay-line input.

The tap point is determined modulo the delay-line length and is relative to the last input value (i.e., a tapDelay of zero returns the last input value).

## ◆ nextOut()

StkFloat stk::DelayA::nextOut | ( | void |  | ) |
| inline

Return the value which will be output by the next call to tick().

This method is valid only for delay settings greater than zero!

126{
127 if ( doNextOut_ ) {
128 // Do allpass interpolation delay.
129 nextOutput_ = -coeff_ * lastFrame_[0];
130 nextOutput_ += apInput_ + ( coeff_ * inputs_[outPoint_] );
131 doNextOut_ = false;
132 }
133
134 return nextOutput_;
135}

## ◆ tick() [1/2]

StkFrames & stk::DelayA::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

157{
158#if defined(_STK_DEBUG_)
159 if ( channel >= frames.channels() ) {
160 oStream_ << "DelayA::tick(): channel and StkFrames arguments are incompatible!";
161 handleError( StkError::FUNCTION_ARGUMENT );
162 }
163#endif
164
165 StkFloat *samples = &frames[channel];
166 unsigned int hop = frames.channels();
167 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
168 inputs_[inPoint_++] = *samples * gain_;
169 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
170 *samples = nextOut();
171 lastFrame_[0] = *samples;
172 doNextOut_ = true;
173 apInput_ = inputs_[outPoint_++];
174 if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
175 }
176
177 return frames;
178}
stk::DelayA::nextOut
StkFloat nextOut(void)
Return the value which will be output by the next call to tick().
Definition DelayA.h:125
stk::StkFrames::size
size_t size() const
Returns the total number of audio samples represented by the object.
Definition Stk.h:374
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::DelayA::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

181{
182#if defined(_STK_DEBUG_)
183 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
184 oStream_ << "DelayA::tick(): channel and StkFrames arguments are incompatible!";
185 handleError( StkError::FUNCTION_ARGUMENT );
186 }
187#endif
188
189 StkFloat *iSamples = &iFrames[iChannel];
190 StkFloat *oSamples = &oFrames[oChannel];
191 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
192 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
193 inputs_[inPoint_++] = *iSamples * gain_;
194 if ( inPoint_ == inputs_.size() ) inPoint_ = 0;
195 *oSamples = nextOut();
196 lastFrame_[0] = *oSamples;
197 doNextOut_ = true;
198 apInput_ = inputs_[outPoint_++];
199 if ( outPoint_ == inputs_.size() ) outPoint_ = 0;
200 }
201
202 return iFrames;
203}

The documentation for this class was generated from the following file:

- DelayA.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.